using System;
using System.Collections.Generic;
using System.Threading.Tasks;
using Posts.WebApi.Models.Entities;
using Posts.WebApi.Models.Enums;
using Posts.WebApi.Models.Models;

namespace Posts.WebApi.DataAccess
{
    public interface IPostRepository : IRepository<Post>
    {
        Task<IEnumerable<Post>> GetPostsBySubjectAsync(int subjectId,
            int groupId = 0, int? semester = 0, int? course = 0, int skip = 0, int take = 0);
        Task<IEnumerable<PostBySemesterGroup>> GetInitialGroupedPostsBySubjectAsync(int subjectId,
        string title = "", int groupId = 0, int? semester = 0, int? course = 0, EPostValueType? valueType = null,
        DateTimeOffset? givenDateFrom = null, DateTimeOffset? givenDateTo = null);
        Task<IEnumerable<Post>> GetFullUsersPostAsync(int userId, int skip, int take);
    }
}