using AutoMapper;
using Posts.WebApi.Models.Entities;
using Posts.WebApi.Models.Enums;
using Posts.WebApi.Models.ModelDto;

namespace Posts.WebApi.Helpers.Mappers
{
    public class ModelToViewMapperProfile : Profile
    {
        public ModelToViewMapperProfile()
        {
            CreateMap<int, EPostLocationType>().ConstructUsing(i => (EPostLocationType)i);
            CreateMap<int, EPostValueType>().ConstructUsing(i => (EPostValueType)i);

            CreateMap<Post, PostLongDto>()
               .ForMember(p => p.PostValueType, opt => opt.MapFrom(src => src.PostValueTypeId));

            CreateMap<Post, PostShortDto>()
            .ForMember(p => p.PostValueType, opt => opt.MapFrom(src => src.PostValueTypeId));

            CreateMap<Post, PostProfileDto>()
            .ForMember(p => p.PostValueType, opt => opt.MapFrom(src => src.PostValueTypeId));

            CreateMap<FileEntity, FileDto>();
        }
    }
}