using Posts.WebApi.Models.Enums;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;

namespace Posts.WebApi.Models.Requests
{
    public class AddPostRequest
    {
        [Required]
        [StringLength(500, MinimumLength = 5)]
        public string Title { get; set; }
        public string Description { get; set; }
        [Required]
        public int Semester { get; set; }
        [Required]
        public int Course { get; set; }
        public EPostValueType? PostValueType { get; set; }
        public DateTime? GivenAt { get; set; }
        [Required]
        public int SubjectId { get; set; }
        [Required]
        public int GroupId { get; set; }

        public IEnumerable<FileInfoRequest> FileInfoRequests { get; set; }
    }
}