using Posts.WebApi.Models.Enums;
using Posts.WebApi.Models.ModelDto;
using Posts.WebApi.Models.Models;
using Posts.WebApi.Models.Requests;
using System;
using System.Collections.Generic;
using System.Threading.Tasks;


namespace Posts.WebApi.Services
{
    public interface IPostService
    {
        Task<ServiceResult<IEnumerable<PostShortDto>>> GetPostsAsync(int facultyId, int userId,
                string title = "", int groupId = 0, int? semester = 0, int? course = 0, EPostValueType? valueType = null,  
                DateTimeOffset? givenDateFrom = null, DateTimeOffset? givenDateTo = null, int skip = 0, int take = 0);

        Task<ServiceResult<object>> DeletePostAsync(string postId, int userId, ERoleType roleType);
        Task<ServiceResult<PostLongDto>> UpdatePostAsync(AddPostRequest request, string postId, int userId);
        Task<ServiceResult<IEnumerable<PostBySemesterGroupDto>>> GetListOfInitialPostsAsync(int facultyId, int userId,
            string title = "", int groupId = 0, int? semester = 0, int? course = 0, EPostValueType? valueType = null, 
            DateTimeOffset? givenDateFrom = null, DateTimeOffset? givenDateTo = null);
        Task<ServiceResult<IEnumerable<PostProfileDto>>> GetUsersPostsAsync(int userId, int skip, int take);
        Task<ServiceResult<PostLongDto>> GetPostFullInfoAsync(string postId, int userId, ERoleType userRole);
        Task<ServiceResult<PostLongDto>> CreatePostAsync(AddPostRequest request, int userId);

        Task<ServiceResult<PostLongDto>> ValidatePostAsync(string postId);
    }
}