import { CanActivate, Router } from '@angular/router';
import { Injectable } from '@angular/core';
import * as fromStore from '../../model/store/index';
import { PopupService } from '../../../../services';
import { Store } from '@ngrx/store';
import { getAccessToken } from '../../model/store/index';

@Injectable()
export class AuthenticationGuard implements CanActivate {

    private accessToken: string | undefined;

    constructor(private store: Store<fromStore.AuthenticationState>,
         private popupService: PopupService,
         private router: Router) {
        this.store.select(getAccessToken).subscribe(t => this.accessToken = t);
    }

    public canActivate(): boolean {
        if (this.accessToken) {
            return true;
        }
        this.router.navigate(['authorization']);
        this.popupService.showError('Sorry, you are not authorized');
        return false;
    }
}