import { Injectable } from '@angular/core';
import { HttpHeaders, HttpClient } from '@angular/common/http';

import { environment } from '@environments/environment';
import { UserProfile } from '@app/shared/models';

const httpOptions = {
  headers: new HttpHeaders({
    'Content-Type': 'application/json',
  }),
};

@Injectable()
export class ProfileService {
  constructor(private http: HttpClient) {}

  public getProfileById(id: number): Promise<UserProfile> {
    return this.http.get<UserProfile>(environment.urlServerAddress + 'users/' + id, httpOptions).toPromise();
  }
}
