import { Injectable, Inject } from '@angular/core';
import { University } from '@app/shared/models/university';
import { UniversityWebServiceToken, UniversityWebService } from './university-web.service';


@Injectable()
export class UniversityService {

    constructor(@Inject(UniversityWebServiceToken) private universityWebService: UniversityWebService) { }

    getUniversities(cityId: number, skip: number, take: number = 10): Promise<University[]> {
        return new Promise<University[]>(async (resolve, reject) => {
            try {
                const result = await this.universityWebService.getUniversities(cityId, skip, take);
                resolve(result.map(t => University.assemble(t)));
            } catch (error) {
                reject(error);
            }
        });
    }
}
