import { Injectable } from '@angular/core';
import { AbstractControl, ValidatorFn } from '@angular/forms';


@Injectable()
export class ValidationService {

    ValidationService()
    {
        
    }
    
    public getEmailErrorMessage(control: AbstractControl) {
        return control.hasError('required') ? 'You must enter a value' :
            control.hasError('email') ? 'Not a valid email' :
                '';
    }
    public getPasswordErrorMessage(control: AbstractControl) {
        return control.hasError('required') ? 'You must enter a value' :
            control.hasError('minlength') ? 'Value must be longer then 8 symbols' :
                '';
    }

    public getConfirmPasswordErrorMessage(control: AbstractControl) {
        return control.hasError('required') ? 'You must enter a value' :
            control.hasError('mismatch') ? 'Passwords must be equal' :
                '';
    }

    public getUsernameErrorMessage(control: AbstractControl) {
        return control.hasError('required') ? 'You must enter a username' :
                control.hasError('maxlength') ? 'Username must be less then 32 symbols' :
                control.hasError('minlength') ? 'Username must be longer then 5 symbols' :
                control.hasError('pattern') ? 'Username must include only A-Z, a-z, 0-9, \".\", \"-\", \"_\"' :
                    '';
    }

    public getPostTitleErrorMessage(control: AbstractControl) {
        return control.hasError('required') ? 'You must enter a post title' :
                control.hasError('maxlength') ? 'Post title must be less then 500 symbols' :
                control.hasError('minlength') ? 'Post title must be longer then 5 symbols' :
                    '';
    }

    public getDescriptionErrorMessage(control: AbstractControl) {
        return control.hasError('maxlength') ? 'Descriptions must be less then 256 symbols' :
            '';
    }

    public getRequiredErrorMessage(control: AbstractControl) {
        return control.hasError('required') ? 'You must enter a value' :
            '';
    }

    public passwordMatchValidator(verifier: AbstractControl, verifiable: AbstractControl): ValidatorFn {
        return (control: AbstractControl): { [key: string]: any } | null => {
            if (!control.parent!) {
                return null;
            }
            return verifier.value === verifiable.value ? null : { 'mismatch': true };
        };
    }

}
