import { Component, OnInit, Input } from '@angular/core';
import { Post } from '@app/shared/models';
import { Router } from '@angular/router';
import { MatDialog } from '@angular/material/dialog';

@Component({
  selector: 'app-single-post-select-card',
  templateUrl: './single-post-select-card.component.html',
  styleUrls: ['./single-post-select-card.component.scss'],
})
export class SinglePostSelectCardComponent implements OnInit {
  @Input() post: Post;
  subjectId: number;
  isLoadMore: boolean;

  constructor(public router: Router, public dialog: MatDialog) {}

  public ngOnInit() {}

  public navigateToPost(post: Post): void {
    this.router.navigate(['post/' + post.id]);
  }
}
