import { Component, Input, Output, EventEmitter } from '@angular/core';
import { Subject } from '@shared/models/subject';

@Component({
  selector: 'app-subject-select-card',
  templateUrl: './subject-select-card.component.html',
  styleUrls: ['./subject-select-card.component.scss'],
})
export class SubjectSelectCardComponent {
  @Input() subject: Subject;
  @Output() subjectSelect = new EventEmitter<Subject>();

  constructor() {}

  public onSubjectSelect() {
    if (this.subject) {
      this.subjectSelect.emit(this.subject);
    } else throw new Error('subject card try to emit undefined value');
  }
}
