import { Action } from '@ngrx/store';
import { City } from '@app/shared/models';

export enum SearchCityActionTypes {
  LoadCityStart = '[SearchCity] Load City Start',
  LoadCitySuccess = '[SearchCity] Load City Success',
  LoadCityFailure = '[SearchCity] Load City Failure',
  SelectCity = '[SearchCity] Select City',
  SetSearchCityInitialState = '[SearchCity] Set Initial State',
}

export class LoadCityStart implements Action {
  readonly type = SearchCityActionTypes.LoadCityStart;
  constructor(public countryId: number) {}
}

export class LoadCitySuccess implements Action {
  readonly type = SearchCityActionTypes.LoadCitySuccess;
  constructor(public cities: City[]) {}
}

export class LoadCityFailure implements Action {
  readonly type = SearchCityActionTypes.LoadCityFailure;
  constructor(public errorMessage: string) {}
}

export class SelectCity implements Action {
  readonly type = SearchCityActionTypes.SelectCity;
  constructor(public City: City | undefined) {}
}

export class SetSearchCityInitialState implements Action {
  readonly type = SearchCityActionTypes.SetSearchCityInitialState;
}

export type SearchCityAction = LoadCitySuccess | LoadCityStart | LoadCityFailure | SelectCity | SetSearchCityInitialState;
