import { Action } from '@ngrx/store';
import { PostByGroupSemester } from '@app/shared/models';

export enum SearchPostActionTypes {
  LoadInitialPostsStart = '[SearchPost] Load Initial Posts Start',
  LoadInitialPostsSuccess = '[SearchPost] Load Initial Posts Success',
  LoadInitialPostsFailure = '[SearchPost] Load Initial Posts Failure',
  LoadPosts = '[SearchPost] Load Posts',
}

export class LoadInitialPostsStart implements Action {
  readonly type = SearchPostActionTypes.LoadInitialPostsStart;
  constructor(public subjectId: number) {}
}

export class LoadInitialPostsSuccess implements Action {
  readonly type = SearchPostActionTypes.LoadInitialPostsSuccess;
  constructor(public postCards: PostByGroupSemester[]) {}
}

export class LoadInitialPostsFailure implements Action {
  readonly type = SearchPostActionTypes.LoadInitialPostsFailure;
  constructor(public message: string) {}
}

export class LoadPosts implements Action {
  readonly type = SearchPostActionTypes.LoadPosts;
  constructor(
    public subjectId: number,
    public groupId: number,
    public semester: number,
    public course: number,
    public skip: number,
    public take: number,
  ) {}
}

export type SearchPostActions = LoadInitialPostsStart | LoadInitialPostsSuccess | LoadInitialPostsFailure | LoadPosts;
