import { Injectable } from '@angular/core';
import { Actions, Effect, ofType } from '@ngrx/effects';
import * as fromAction from '../actions';
import { tap, filter } from 'rxjs/operators';
import { Router } from '@angular/router';

const routs = {
  university: 'select/university',
  faculty: 'select/faculty',
  subject: 'select/subject',
};

@Injectable()
export class SearchBreadcrumbsEffects {
  constructor(private actions$: Actions, private router: Router) {}

  @Effect()
  PressCountry = this.actions$.pipe(
    ofType(fromAction.SearchBreadcrumbsActionTypes.PressCountry),
    tap(() => {
      if (this.router.url != routs.university) this.router.navigate([routs.university]);
    }),
    filter(() => false),
  );

  @Effect()
  PressCity = this.actions$.pipe(
    ofType(fromAction.SearchBreadcrumbsActionTypes.PressCity),
    tap(() => {
      if (this.router.url != routs.university) this.router.navigate([routs.university]);
    }),
    filter(() => false),
  );

  @Effect()
  PressUniversity = this.actions$.pipe(
    ofType(fromAction.SearchBreadcrumbsActionTypes.PressUniversity),
    tap(() => {
      if (this.router.url != routs.faculty) this.router.navigate([routs.faculty]);
    }),
    filter(() => false),
  );

  @Effect()
  PressFaculty = this.actions$.pipe(
    ofType(fromAction.SearchBreadcrumbsActionTypes.PressFaculty),
    tap(() => {
      if (this.router.url != routs.subject) this.router.navigate([routs.subject]);
    }),
    filter(() => false),
  );
}
