import { ActionReducer } from '@ngrx/store';
import { getSavedState, setSavedState } from '@shared/helpers/local-storage.helper';

const SEARCH_STATE_KEY = 'searchState';

export function searchPersistentReducer(reducer: ActionReducer<any>): ActionReducer<any> {
  let onInit = true;
  return function (state, action) {
    let stateToSave = reducer(state, action);
    if (onInit) {
      onInit = false;
      stateToSave = Object.assign(stateToSave, getSavedState(SEARCH_STATE_KEY));
    } else {
      setSavedState(stateToSave, SEARCH_STATE_KEY);
    }
    return stateToSave;
  };
}
