import { PostByGroupSemester } from '@app/shared/models';
import * as fromPostAction from '../actions/search-post.actions';


export interface SearchPostState {
  loading: boolean;
  postCards: PostByGroupSemester[];
}

export const initialState: SearchPostState = {
  postCards: [],
  loading: false
}; 

export function reducer(state = initialState, action: fromPostAction.SearchPostActions): SearchPostState {
  switch (action.type) {
    case fromPostAction.SearchPostActionTypes.LoadInitialPostsStart: {
      return {
          ...state,
          loading: true
      };
  }
    case fromPostAction.SearchPostActionTypes.LoadInitialPostsSuccess: {
      return {...state, postCards: action.postCards, loading: false};
    }
    case fromPostAction.SearchPostActionTypes.LoadInitialPostsFailure: {
      return {...state, loading: false};
  }
    default:
      return state;
  }
}
