import { getSelectedCity } from './search-city.selectors';
import { getSelectedCountry } from './search-country.selectors';
import { createSelector } from '@ngrx/store';
import { Country, City, Faculty } from '@app/shared/models';
import { getSelectedUniversity } from './search-university.selectors';
import { University } from '@app/shared/models/university';
import { getSelectedFaculty } from './search-faculty.selectors';
import { getSelectedSubject } from './search-subject.selector';
import { Subject } from '@app/shared/models/subject';

export const isUniversityCanBeSelected = createSelector(
  getSelectedCity,
  getSelectedCountry,
  (selectedCity: City | undefined, selectedCountry: Country | undefined): boolean => (selectedCity && selectedCountry ? true : false),
);

export const isFacultyCanBeSelected = createSelector(
  isUniversityCanBeSelected,
  getSelectedUniversity,
  (isUniversityCanBeSelected: boolean, selectedUniversity: University | undefined): boolean =>
    isUniversityCanBeSelected && selectedUniversity ? true : false,
);

export const isSubjectCanBeSelected = createSelector(
  isFacultyCanBeSelected,
  getSelectedFaculty,
  (isFacultyCanBeSelected: boolean, selectedFaculty: Faculty | undefined): boolean =>
    isFacultyCanBeSelected && selectedFaculty ? true : false,
);

export const isPostCanBeSelected = createSelector(
  isSubjectCanBeSelected,
  getSelectedSubject,
  (isSubjectCanBeSelected: boolean, selectedFaculty: Subject | undefined) => (isSubjectCanBeSelected && selectedFaculty ? true : false),
);
