import { createSelector } from '@ngrx/store';

import * as fromSearch from '../reducers';
import * as fromFaculty from '../reducers/search-faculty.reducer';

export const getFacultiesState = createSelector(fromSearch.getSearchState, (state: fromSearch.SearchState) => state.searchFacultyState);

export const getFacultiesCount = createSelector(getFacultiesState, (state: fromFaculty.SearchFacultyState) => state.ids.length);

export const getAllFaculties = createSelector(getFacultiesState, (state: fromFaculty.SearchFacultyState) => fromFaculty.selectAll(state));

export const getSelectedFaculty = createSelector(getFacultiesState, (state: fromFaculty.SearchFacultyState) => state.selectedFaculty);

export const getFacultyLoading = createSelector(getFacultiesState, (state: fromFaculty.SearchFacultyState) => state.loading);
