import { createSelector } from '@ngrx/store';

import * as fromSearch from '../reducers/index';
import * as fromUniversity from '../reducers/search-university.reducer';

export const getUniversitiesState = createSelector(
  fromSearch.getSearchState,
  (state: fromSearch.SearchState) => state.searchUniversityState,
);

export const getUniversitiesCount = createSelector(getUniversitiesState, (state: fromUniversity.SearchUniversityState) => state.ids.length);

export const getAllUniversities = createSelector(getUniversitiesState, (state: fromUniversity.SearchUniversityState) =>
  fromUniversity.selectAll(state),
);

export const getSelectedUniversity = createSelector(
  getUniversitiesState,
  (state: fromUniversity.SearchUniversityState) => state.selectedUniversity,
);
