import { NgModule } from '@angular/core';
import { Routes, RouterModule } from '@angular/router';

import { UniSearchRootComponent } from './components/univer-select/uni-search-root/uni-search-root.component';
import { FacultySelectRootComponent } from './components/faculty-select/faculty-select-root/faculty-select-root.component';
import { PostSelectRootComponent } from './components/post-select/post-select-root/post-select-root.component';
import { SubjectSelectRootComponent } from './components/subject-select/subject-select-root/subject-select-root.component';
import { CreatePostComponent } from './components';

const routes: Routes = [
  {
    path: 'faculty',
    component: FacultySelectRootComponent,
  },
  {
    path: 'subject',
    component: SubjectSelectRootComponent,
  },
  {
    path: 'university',
    component: UniSearchRootComponent,
  },
  {
    path: 'post',
    component: PostSelectRootComponent,
  },
  {
    path: ':id/edit',
    component: CreatePostComponent,
  },
  {
    path: 'post/new',
    component: CreatePostComponent,
  },
  {
    path: '**',
    redirectTo: 'university',
    pathMatch: 'full',
  },
];

@NgModule({
  imports: [RouterModule.forChild(routes)],
  exports: [RouterModule],
})
export class SearchRoutingModule {}
