import { CommonModule } from '@angular/common';
import { NgModule } from '@angular/core';
import { EffectsModule } from '@ngrx/effects';
import { StoreModule } from '@ngrx/store';
import { SharedModule } from '@shared/shared.module';
import * as fromComponents from './components';
import { effects, reducers } from './model/store/index';
import { SearchRoutingModule } from './search-routing.module';
import { FacultyService } from './services/web/faculty.service';
import { SubjectWebService } from './services/web/subject.service';
import { PostsService } from './services/web/posts.service';
import { CityService } from './services/web/city.service';
import { CountryService } from './services/web/country.service';
import { searchPersistentReducer } from './model/store/reducers/search-persistent.reducer';

@NgModule({
  declarations: [
    fromComponents.FacultySelectRootComponent,
    fromComponents.FacultyCardComponent,
    fromComponents.PostGroupedSelectCardComponent,
    fromComponents.SinglePostSelectCardComponent,
    fromComponents.PostSelectRootComponent,
    fromComponents.SubjectSelectCardComponent,
    fromComponents.SubjectSelectRootComponent,
    fromComponents.UniSearchCardComponent,
    fromComponents.UniSearchContentComponent,
    fromComponents.UniSearchFilterComponent,
    fromComponents.UniSearchRootComponent,
    fromComponents.SearchBreadcrumbComponent,
    fromComponents.CreatePostComponent,
  ],
  imports: [
    CommonModule,
    SearchRoutingModule,
    SharedModule,
    StoreModule.forFeature('search', reducers, { metaReducers: [searchPersistentReducer] }),
    EffectsModule.forFeature(effects),
  ],
  exports: [],
  providers: [SubjectWebService, PostsService, FacultyService, CityService, CountryService],
})
export class SearchModule {}
