import { Injectable } from '@angular/core';

import { City } from '@app/shared/models/city';
import { HttpClient } from '@angular/common/http';
import { Observable } from 'rxjs';
import { environment } from '@environments/environment';

@Injectable()
export class CityService {
  constructor(private http: HttpClient) {}

  public getCities(countryId: number): Observable<City[]> {
    return this.http.get<City[]>(environment.urlServerAddress + 'Cities?countryId=' + countryId);
  }
}
