import { Component, Output, EventEmitter, Input } from '@angular/core';

@Component({
  selector: 'app-breadcrumb',
  templateUrl: './breadcrumb.component.html',
  styleUrls: ['./breadcrumb.component.scss'],
})
export class BreadcrumbComponent {
  @Output() itemChanged = new EventEmitter<string>();
  @Input() public divider: string = '/';

  public items = new Array<string>();
  public translatableItems: Array<number> = [0, 1];

  public addItem(item: string) {
    this.items.push(item);
  }

  public clearAll() {
    this.items = [];
  }

  public deleteAllItemsAfterNth(n: number) {
    this.items = this.items.slice(0, n);
  }

  public onItemClick(item: string) {
    this.itemChanged.emit(item);
  }
}
