import { Component, Input, Output, EventEmitter } from '@angular/core';
import { File } from '@app/shared/models/file';

@Component({
  selector: 'app-post-file',
  templateUrl: './post-file.component.html',
  styleUrls: ['./post-file.component.scss'],
})
export class PostFileComponent {
  @Input() file: File;
  @Input() isFileCanBeDeleted: boolean = true;

  @Output() deleteFile = new EventEmitter<string>();
  @Output() openFile = new EventEmitter<string>();

  public onDeleteFile() {
    this.deleteFile.emit(this.file.url);
  }

  public onFileClick() {
    this.openFile.emit(this.file.url);
  }
}
