using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Uni.WebApi.ApplicationCore.Services.Contract;
using Uni.WebApi.Models.ModelDto;
using Uni.WebApi.Web.Helpers.Mappers;

namespace Uni.WebApi.Controllers
{
    [ApiVersion("1.0")]
    [Route("/v{api-version:apiVersion}/[controller]")]
    [ApiController]

    public class UserController : BaseController
    {
        private readonly IServiceResultMapper _viewMapper;
        private readonly IUserService _usersService;

        public UserController(
            IServiceResultMapper viewMapper,
            IUserService userService)
        {
            this._viewMapper = viewMapper;
            this._usersService = userService;
        }

        [HttpGet("{userId}")]
        public async Task<ActionResult<UserDto>> GetUsersProfileAsync([FromRoute] int userId)
        => this._viewMapper.ServiceResultToContentResult(
                await this._usersService.GetUserAsync(userId));
    }
}