using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.EntityFrameworkCore;
using Uni.WebApi.DataAccess.RepositoryService.Interfaces;
using Uni.WebApi.Kernel.Entities;

namespace Uni.WebApi.DataAccess.RepositoryService.Repositories
{
    public class FacultyRepository : BaseRepository<Faculty>, IFacultyRepository
    {
        public FacultyRepository(UniDbContext dbContext) : base(dbContext)
        {
        }

        public async Task<IEnumerable<Faculty>> GetFacultiesByUniversityAsync(int universityId, int skip, int take)
        {
            return await _dbContext.Faculties
                                    .Where(f => f.UniversityId == universityId)
                                    .OrderBy(f => f.Id)
                                    .Skip(skip).Take(take)
                                    .ToListAsync();
        }
    }
}