using System;
using System.ComponentModel.DataAnnotations.Schema;
using Uni.WebApi.Kernel.Entities.Base;

namespace Uni.WebApi.Kernel.Entities
{
    public class File : BaseEntity
    {
        public string Name { get; set; }
        public string Path { get; set; }
        public DateTime? DeletedAtUtc { get; set; }
        
        public int FileTypeId { get; set; }
        [ForeignKey(nameof(FileTypeId))]
        public FileType Type { get; set; }

        public int UserAuthorId { get; set; }
        [ForeignKey(nameof(UserAuthorId))]
        public virtual User UserAuthor { get; set; }
    }
}