using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using Uni.WebApi.Kernel.Entities.Base;

namespace Uni.WebApi.Kernel.Entities
{
    public class Group : BaseEntity
    {
        [Required]
        [StringLength(50, MinimumLength = 3)]
        public string Title { get; set; }
        [Required]
        public int YearStart { get; set; }
        public DateTime ModifiedAtUtc { get; set; }
        public DateTime? DeletedAtUtc { get; set; }

        public int FacultyId { get; set; }
        [ForeignKey(nameof(FacultyId))]
        public virtual Faculty Faculty { get; set; }
    }
}