using System;
using System.ComponentModel;

namespace Uni.WebApi.Kernel
{
    public class StatusException : Exception
    {
        public int Status { get; set; }

        private StatusException(int status, string message) : base(message)
        {
        }

        public static StatusException Create(EExceptionStatus status)
        {
            string message;

            switch (status)
            {
                case EExceptionStatus.NoRights:
                    message = "You don't have rights to do this action";
                    break;
                default:
                    throw new InvalidEnumArgumentException();
            }

            return new StatusException((int)status, message);
        }
    }
}