using Microsoft.Extensions.DependencyInjection;
using Uni.WebApi.ApplicationCore.Services;
using Uni.WebApi.ApplicationCore.Services.Contract;
using Uni.WebApi.ApplicationCore.Services.Shared;
using Uni.WebApi.ApplicationCore.Services.Shared.Contract;

namespace Uni.WebApi.Web.Extensions.StartupExtensions
{
    public static class ServiceLayerExtension
    {
        public static void AddServiceLayer(this IServiceCollection services)
        {
            services.AddTransient<IAuthorizationService, AuthorizationService>();
            services.AddTransient<IEmailService, EmailService>();
            services.AddTransient<IUniversityService, UniversityService>();
            services.AddTransient<ICityService, CityService>();
            services.AddTransient<ICountryService, CountryService>();
            services.AddTransient<IFacultyService, FacultyService>();
            services.AddTransient<IUserService, UserService>();
            services.AddTransient<IFileService, FileService>();
            services.AddTransient<ISubjectService, SubjectService>();
            services.AddTransient<IGroupService, GroupService>();
            services.AddTransient<IRefreshTokenService, RefreshTokenService>();
            services.AddTransient<ITeacherService, TeacherService>();
        }
    }
}