using AutoMapper;
using Uni.WebApi.Kernel.Entities;
using Uni.WebApi.Models.Enums;
using Uni.WebApi.Models.ModelDto;

namespace Uni.WebApi.Web.Helpers.Mappers
{
    public class ModelToViewMapperProfile : Profile
    {
        public ModelToViewMapperProfile()
        {
            CreateMap<User, UserDto>();
            CreateMap<University, UniversityDto>();
            CreateMap<Country, CountryDto>();
            CreateMap<Faculty, FacultyDto>();
            CreateMap<Subject, SubjectDto>();
            CreateMap<City, CityDto>();

            CreateMap<File, FileDto>()
            .ForMember(f => f.FileType, opt => opt.MapFrom(src => src.FileTypeId))
            .ForMember(f => f.Url, opt => opt.MapFrom(src => src.Path));

            CreateMap<Teacher, TeacherDto>();
            
            CreateMap<Group, GroupDto>();
        }
    }
}